//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Client.BinaryTransferTest.BinaryTransferTest
{
    
    
    /// <summary>
    /// Class that implements the IBinaryTransferTest interface through SiLA2
    /// </summary>
    public partial class BinaryTransferTestClient : IBinaryTransferTest
    {
        
        private System.Lazy<System.IO.Stream> _binaryValueDirectly;
        
        private System.Lazy<System.IO.Stream> _binaryValueDownload;
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.binarytransfertest.v1.BinaryTransferTest";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public BinaryTransferTestClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
            InitLazyRequests();
        }
        
        /// <summary>
        /// Returns the UTF-8 encoded string 'SiLA2_Test_String_Value' directly transmitted as Binary value.
        /// </summary>
        public virtual System.IO.Stream BinaryValueDirectly
        {
            get
            {
                return _binaryValueDirectly.Value;
            }
        }
        
        /// <summary>
        /// Returns the Binary Transfer UUID to be used to download the binary data which is the UTF-8 encoded string
        /// 'A_slightly_longer_SiLA2_Test_String_Value_used_to_demonstrate_the_binary_download', repeated 100,000 times.
        /// </summary>
        public virtual System.IO.Stream BinaryValueDownload
        {
            get
            {
                return _binaryValueDownload.Value;
            }
        }
        
        private System.IO.Stream RequestBinaryValueDirectly()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/BinaryTransferTest/v1/Property/BinaryValueDirectly");
            try
            {
                System.IO.Stream response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.BinaryDto>>(_serviceName, "BinaryValueDirectly", "org.silastandard/test/BinaryTransferTest/v1/Property/BinaryValueDirectly", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private System.IO.Stream RequestBinaryValueDownload()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/BinaryTransferTest/v1/Property/BinaryValueDownload");
            try
            {
                System.IO.Stream response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.BinaryDto>>(_serviceName, "BinaryValueDownload", "org.silastandard/test/BinaryTransferTest/v1/Property/BinaryValueDownload", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Initializes lazies for non-observable properties.
        /// </summary>
        private void InitLazyRequests()
        {
            _binaryValueDirectly = new System.Lazy<System.IO.Stream>(RequestBinaryValueDirectly);
            _binaryValueDownload = new System.Lazy<System.IO.Stream>(RequestBinaryValueDownload);
        }
        
        /// <summary>
        /// Receives a Binary value (transmitted either directly or via binary transfer) and
        /// returns the received value.
        /// </summary>
        /// <param name="binaryValue">The Binary value to be returned.</param>
        public virtual System.IO.Stream EchoBinaryValue(System.IO.Stream binaryValue)
        {
            EchoBinaryValueRequestDto request = new EchoBinaryValueRequestDto(binaryValue, _executionManager.CreateBinaryStore("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryValue/Parameter/Bin" +
                        "aryValue"));
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryValue");
            try
            {
                System.IO.Stream response = _channel.ExecuteUnobservableCommand<EchoBinaryValueRequestDto, EchoBinaryValueResponseDto>(_serviceName, "EchoBinaryValue", request, callInfo).ReceivedValue.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Receives a list of binaries, echoes them individually as intermediate responses with a delay of 1 second, and then returns them as a single joint binary
        /// </summary>
        /// <param name="binaries">List of binaries to echo</param>
        public virtual Tecan.Sila2.IIntermediateObservableCommand<System.IO.Stream, System.IO.Stream> EchoBinariesObservably(System.Collections.Generic.ICollection<System.IO.Stream> binaries)
        {
            EchoBinariesObservablyRequestDto request = new EchoBinariesObservablyRequestDto(binaries, _executionManager.CreateBinaryStore("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinariesObservably/Parame" +
                        "ter/Binaries"));
            request.Validate();
            return _channel.ExecuteIntermediatesCommand<EchoBinariesObservablyRequestDto, System.IO.Stream, EchoBinariesObservablyIntermediateDto, System.IO.Stream, EchoBinariesObservablyResponseDto>(_serviceName, "EchoBinariesObservably", request, ConvertEchoBinariesObservablyIntermediate, ConvertEchoBinariesObservablyResponse, ConvertEchoBinariesObservablyException, _executionManager.CreateCallOptions(request.CommandIdentifier));
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of EchoBinariesObservably to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertEchoBinariesObservablyException(string errorIdentifier, string errorMessage)
        {
            return null;
        }
        
        /// <summary>
        /// Unwraps the response of the EchoBinariesObservablyIntermediate command
        /// </summary>
        /// <param name="value">The response data transfer object</param>
        /// <returns>The actual response</returns>
        private System.IO.Stream ConvertEchoBinariesObservablyIntermediate(EchoBinariesObservablyIntermediateDto value)
        {
            return value.Binary.Extract(_executionManager.DownloadBinaryStore);
        }
        
        /// <summary>
        /// Unwraps the response of the EchoBinariesObservablyResponse command
        /// </summary>
        /// <param name="value">The response data transfer object</param>
        /// <returns>The actual response</returns>
        private System.IO.Stream ConvertEchoBinariesObservablyResponse(EchoBinariesObservablyResponseDto value)
        {
            return value.JointBinary.Extract(_executionManager.DownloadBinaryStore);
        }
        
        /// <summary>
        /// Receives a Binary and requires String Metadata, returns both
        /// </summary>
        /// <param name="binary">The binary to echo</param>
        public virtual EchoBinaryAndMetadataStringResponse EchoBinaryAndMetadataString(System.IO.Stream binary)
        {
            EchoBinaryAndMetadataStringRequestDto request = new EchoBinaryAndMetadataStringRequestDto(binary, _executionManager.CreateBinaryStore("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryAndMetadataString/P" +
                        "arameter/Binary"));
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryAndMetadataString");
            try
            {
                EchoBinaryAndMetadataStringResponse response = _channel.ExecuteUnobservableCommand<EchoBinaryAndMetadataStringRequestDto, EchoBinaryAndMetadataStringResponseDto>(_serviceName, "EchoBinaryAndMetadataString", request, callInfo).Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Binary Transfer Test.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class BinaryTransferTestClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/BinaryTransferTest/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IBinaryTransferTest);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new BinaryTransferTestClient(channel, executionManager);
        }
    }
}

